#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#define _DISPLAY_DATA_LENGTH_ 201

#include <QMainWindow>
#include <QMessageBox>
#include <QSerialPort>
#include <QSerialPortInfo>
#include <QDebug>

#include <QtCharts/QChartGlobal>
#include <QtCharts/QChartView>
#include <QtCharts/QLineSeries>
#include <QtCharts/QChart>
#include <QtCharts/QValueAxis>

QT_BEGIN_NAMESPACE
class QLineSeries;
class QChart;
QT_END_NAMESPACE
QT_USE_NAMESPACE

#include <serial_command.h>
#include <mydialog.h>

QT_BEGIN_NAMESPACE
namespace Ui {
class MainWindow;
}
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();
    void msgBox(QWidget* ctx, QString title, QString content);
    void msgBox(QWidget* ctx, QString content);

    void initFigure();
    void processTempData(uint data);
    void processBodyData(uint data);
    void processGasState(uint data);
    void processGasData(uint data);

private slots:
    void receiveData();

    void on_btn_serial_search_clicked();

    void on_btn_serial_toggle_clicked();

    void on_comboBox_sys_mode_currentIndexChanged(int index);

    void on_comboBox_cycle_currentIndexChanged(int index);

    void on_comboBox_temp_fetch_currentIndexChanged(int index);

    void on_comboBox_body_fetch_currentIndexChanged(int index);

    void on_comboBox_gas_fetch_currentIndexChanged(int index);

    void on_pushButton_temp_details_clicked();

private:
    Ui::MainWindow *ui;

    QSerialPort* m_serialPort;

    QChart *m_chart;
    QChartView *m_chartView;
    QLineSeries *m_series;
    QValueAxis *axisX;
    QValueAxis *axisY;
    float m_maxTemp;
    float m_minTemp;

    QChart *m_chartGas;
    QChartView *m_chartViewGas;
    QLineSeries *m_seriesGas;
    QValueAxis *axisXGas;
    QValueAxis *axisYGas;
};
#endif // MAINWINDOW_H
